#
# Block-Aufgabe Nr. 5
#

# function: coin toss
coin_toss <- function(r, X) {
  return(r * (0.5 / (0.5 * r + X * (1 - r))))
}


# ----------------------------------------------------------------
# 5.1 
#

# create new data frame and add column labels
data.coins_zk <- data.frame(matrix(ncol = 2, nrow = 0))
colnames(data.coins_zk) <- c("turn", "p-value")

# add first row, which is turn 0 with even probability
data.coins_zk[nrow(data.coins_zk) + 1,] = c(0, 0.5)

while(data.coins_zk[nrow(data.coins_zk), "p-value"] < 0.95) { 
  
  # determine coin side and corresponding probability
  ZK <- if((nrow(data.coins_zk) %% 2) != 0) { 0.6 } else { 0.4 }
  
  # calculate new p-value using last p-value and coin side probability
  value <- coin_toss(data.coins_zk[nrow(data.coins_zk), "p-value"], ZK)
  
  # add new data to coins data frame
  data.coins_zk[nrow(data.coins_zk) + 1,] = c(nrow(data.coins_zk), value)
}

# print last two rows and plot data frame
tail(data.coins_zk, 2) # answer: 145
plot(data.coins_zk)


# ----------------------------------------------------------------
# 5.2
#

# create new data frame and add column labels
data.coins_k <- data.frame(matrix(ncol = 2, nrow = 0))
colnames(data.coins_k) <- c("turn", "p-value")

# add first row, which is turn 0 with eveb probability
data.coins_k[nrow(data.coins_k) + 1,] = c(0, 0.5)

while(data.coins_k[nrow(data.coins_k), "p-value"] < 0.95) { 
  
  # calculate new p-value using last p-value and fixed probability of 0.4
  value <- coin_toss(data.coins_k[nrow(data.coins_k), "p-value"], 0.4)
  
  # add new data to coins data frame
  data.coins_k[nrow(data.coins_k) + 1,] = c(nrow(data.coins_k), value)
}

# print last two rows and plot data frame
tail(data.coins_k, 2) # answer: 13
plot(data.coins_k)


# ----------------------------------------------------------------
# 5.3
#

# In diesem Fall ist die Folge KKKK(...) Evidenz für I, 
# d.h. die Antwort in Teil 2 wird deutlich komplizierter. 
# Umgekehrt sollte diese Hypothese in Teil 1 keinen großen Unterschied machen, 
# denn die Wahrscheinlichkeit P(I|ZKZK..) geht rapide gegen 0, 
# und spielt dann in die weiteren Berechnungen kaum eine Rolle.